      PROGRAM biolim

      ! This is the BIOLIM code
      ! composed of the halo-thermodynamic model of Vancoppenolle et al. (JGR 2007)
      ! and of a newly developed biogeochemical component

      ! (c) Martin Vancoppenolle (UCL-ASTR, 2002-2008)

      INCLUDE 'type.com'
      INCLUDE 'const.com'
      INCLUDE 'para.com'
      INCLUDE 'ice.com'
      INCLUDE 'forcing.com'
      INCLUDE 'bio.com'
 
!------------------------------------------------------------------------------
!     1) CREATES THE OUTPUT FILES
!------------------------------------------------------------------------------


      OPEN(numout,file='run.out.txt',status='replace')        ! output text file
      OPEN(503   ,file='cons_bio.out.txt',status='replace')   ! output conservation file
      OPEN(85    ,file='forcing.out.txt',status='replace')
      OPEN(86    ,file='time.step', status='replace')

      WRITE(numout,*) ' ---------------------------------------------- '
      WRITE(numout,*) '         *** BIO-LIM sea ice model ***          '
      WRITE(numout,*) '  (c) UCL-ASTR, Louvain-La-Neuve Belgium        '
      WRITE(numout,*) '  Martin Vancoppenolle, 2008.                   '
      WRITE(numout,*) ' ---------------------------------------------- '
      WRITE(numout,*) 
      WRITE(numout,*) ' biolim :  '
      WRITE(numout,*) ' ~~~~~~~~~ '
      WRITE(numout,*) 
!
!------------------------------------------------------------------------------
!     2) PARAMETERS
!------------------------------------------------------------------------------
!
      CALL ice_phy_param       ! physical parameters

      CALL ice_bio_param       ! biological parameters
!
!-----------------------------------------------------------------------
!     3) MAIN LOOP                                                     |
!-----------------------------------------------------------------------
!
      WRITE(numout,*)
      WRITE(numout,*) ' Loop begins, iteration : ', nstart
      WRITE(numout,*)
      WRITE(numout,*) '  nstart = ', nstart
      WRITE(numout,*) '  nend   = ', nend
      WRITE(numout,*)

      DO 300 numit = nstart, nend  

         !---------------------
         ! Time step variables
         !---------------------
         WRITE(86,*) numit

         WRITE(numout,*) 
     &   '============================================================='
         WRITE(numout,*)
         WRITE(numout,*) '   *** Beginning the time step *** ', numit
         WRITE(numout,*)
         WRITE(numout,*) 
     &   '============================================================='
         WRITE(numout,*)

         CALL ice_th(n_i,n_s) ! main model routine
 
 300  CONTINUE ! End of the loop

!-----------------------------------------------------------------------
!     4) END OF THE RUN                                                |
!-----------------------------------------------------------------------
      ! close output files
      CLOSE(numout) 
      CLOSE(85)
      CLOSE(86)
      CLOSE(999) 
      CLOSE(24)
 
!-----------------------------------------------------------------------------!
! End of the main routine
!
      END
